<?

	class TS_MPD extends IPSModule
	{

		public function __construct($InstanceID)
		{
			//Never delete this line!
			parent::__construct($InstanceID);
			
			//These lines are parsed on Symcon Startup or Instance creation
			//You cannot use variables here. Just static values.
			$this->RegisterPropertyString("IPAddress", "192.168.1.103");
			$this->RegisterPropertyString("Pfad", "file:///music/Network/");
			$this->RegisterPropertyString("Alarm", "alarm-sirene.mp3");
			$this->RegisterPropertyString("Radio1Name", "Radio Lippe");
			$this->RegisterPropertyString("Radio2Name", "FFN");
			$this->RegisterPropertyString("Radio3Name", "FFH");
			$this->RegisterPropertyString("Radio4Name", "OE3");
			$this->RegisterPropertyString("Radio5Name", "Antenne Bayern");
			$this->RegisterPropertyString("Radio1", "tunein:station:s96523");
			$this->RegisterPropertyString("Radio2", "tunein:station:s84672");
			$this->RegisterPropertyString("Radio3", "tunein:station:s223993");
			$this->RegisterPropertyString("Radio4", "tunein:station:s8007");
			$this->RegisterPropertyString("Radio5", "tunein:station:s96752");
			$this->RegisterPropertyString("DisplayId", "0");
			$this->RegisterPropertyString("DisplayZeile", "2");

		}

		public function ApplyChanges()
		{
			//Never delete this line!
			parent::ApplyChanges();

			$this->RegisterScript("_Steuerung", "_Steuerung", '<?
      IPS_SetScriptTimer($_IPS[\'SELF\']  , 30);                  // ScriptTimer einschalten (auf 60 Sekunde setzen)
      switch ($_IPS["SENDER"])                                     // Ursache (Absender) des Triggers ermittlen
{
  case "WebFront": //zum ersten Start
      IPS_SetScriptTimer($_IPS[\'SELF\']  , 30);                  // ScriptTimer einschalten (auf 60 Sekunde setzen)
  		IPS_SetHidden(IPS_GetObjectIDByName(\'Radiotitel_alt\', IPS_GetParent($_IPS[\'SELF\'])), true);
	  	IPS_SetHidden(IPS_GetObjectIDByName(\'_Steuerung\', IPS_GetParent($_IPS[\'SELF\'])), true);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Volume\', IPS_GetParent($_IPS[\'SELF\'])), 1);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Mute\', IPS_GetParent($_IPS[\'SELF\'])), 5);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Radiotitel\', IPS_GetParent($_IPS[\'SELF\'])), 6);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Sender\', IPS_GetParent($_IPS[\'SELF\'])), 7);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Station\', IPS_GetParent($_IPS[\'SELF\'])), 8);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Status\', IPS_GetParent($_IPS[\'SELF\'])), 9);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Alarm_abspielen\', IPS_GetParent($_IPS[\'SELF\'])), 20);
//      IPS_SetPosition(IPS_GetObjectIDByName(\'Logo\', IPS_GetParent($_IPS[\'SELF\'])), 30);


  case "TimerEvent":                                     // Timer hat getriggert

$s_radio = GetValueString(IPS_GetObjectIDByName(\'Radiotitel\', IPS_GetParent($_IPS[\'SELF\'])));
$ip = IPS_GetProperty(IPS_GetParent($_IPS[\'SELF\']), "IPAddress");
if (Sys_Ping($ip, 1000) == true) {
include("../modules/Ts/TS_Mpd/mpd.php");

$mpd = new PHPmpd($ip); //mpd IPAdresse
//$s_steuer = $mpd->GetTransportInfo();
//SetValueInteger(IPS_GetObjectIDByName(\'Status\', IPS_GetParent($_IPS[\'SELF\'])) , $s_steuer);
// print_r ($mpd->GetMediaInfo());
$s_radio = $mpd->GetMediaInfo();
SetValueString(IPS_GetObjectIDByName(\'Sender\', IPS_GetParent($_IPS[\'SELF\'])) , $s_radio[2]);

$mute = $mpd->GetMute();
if ($mute == 1)
{
  SetValueInteger(IPS_GetObjectIDByName(\'Mute\', IPS_GetParent($_IPS[\'SELF\']))  , 1);
}
if ($mute == 0)
{
  SetValueInteger(IPS_GetObjectIDByName(\'Mute\', IPS_GetParent($_IPS[\'SELF\'])), 0);
}

$s_vol = $mpd->GetVolume();;
SetValueInteger(IPS_GetObjectIDByName(\'Volume\', IPS_GetParent($_IPS[\'SELF\'])) , $s_vol);

$ret = $mpd->GetTransportInfo();
SetValueInteger(IPS_GetObjectIDByName(\'Status\', IPS_GetParent($_IPS[\'SELF\']))  , $ret);

} // if sys_ping
else {
SetValueInteger(IPS_GetObjectIDByName(\'Status\', IPS_GetParent($_IPS[\'SELF\']))  , 3);
SetValueInteger(IPS_GetObjectIDByName(\'Volume\', IPS_GetParent($_IPS[\'SELF\'])) , 0);

}




break;}
?>');

$this->RegisterScript("Alarm_abspielen", "Alarm_abspielen", '<? 
$ip = IPS_GetProperty(IPS_GetParent($_IPS[\'SELF\']), "IPAddress");
$pfad = IPS_GetProperty(IPS_GetParent($_IPS[\'SELF\']), "Pfad");
$alarm = IPS_GetProperty(IPS_GetParent($_IPS[\'SELF\']), "Alarm");
if (Sys_Ping($ip, 1000) == true) {
include("../modules/Ts/TS_Mpd/mpd.php");
$mpd = new PHPmpd($ip); //mpd IPAdresse

 $ton="alarm";

$wav = array
(
   "test"    => "x-file-cifs://192.168.1.12/nas/alarm-sirene.mp3",
   "alarm"   => $pfad.$alarm,
   "bell"    => "x-file-cifs://".$pfad."alarm-sirene.mp3"
);
$volume                         = $mpd->GetVolume();                 

//Speichern der Aktuellen Informationen
$s_radio = $mpd->GetMediaInfo();
$oldpi = $s_radio[2];
$oldmi = $s_radio[1];

//$radio=(strpos($oldmi[\'CurrentURI\'],"x-sonosapi-stream:")>0)===false;
//print_r ($oldmi[\'CurrentURI\']);

$oldti = $mpd->GetTransportInfo();

$mpd->SetVolume(5);
$mpd->SetRadio($wav[$ton]);
$mpd->Play();
// print_r ($wav[$ton]);
IPS_Sleep(1000);

while ($mpd->GetTransportInfo()==1)
{
    IPS_Sleep(200); //Alle 200ms wird abgefragt
}

//Player wieder Starten
$mpd->SetRadio($oldmi);
//print_r ($oldmi);
if ($oldti==1) $mpd->Play();
$mpd->SetVolume($volume);
}
?>');


			$this->RegisterProfileIntegerEx("Status.SONOS", "Information", "", "", Array(
				Array(0, "Prev", "", -1),
				Array(1, "Play", "", -1),
				Array(2, "Pause", "", -1),
				Array(3, "Stop", "", -1),
				Array(4, "Next", "", -1)
			));
			$this->RegisterProfileIntegerEx("Schalter.SONOS", "Information", "", "", Array(
				Array(0, "Off", "", 0xFF0000),
				Array(1, "On", "", 0x00FF00)
			));
			$this->RegisterProfileIntegerEx("Station.SONOS", "Information", "", "", Array(
				Array(0, $this->ReadPropertyString("Radio1Name"), "", -1),
				Array(1, $this->ReadPropertyString("Radio2Name"), "", -1),
				Array(2, $this->ReadPropertyString("Radio3Name"), "", -1),
				Array(3, $this->ReadPropertyString("Radio4Name"), "", -1),
				Array(4, $this->ReadPropertyString("Radio5Name"), "", -1),
			));
			$this->RegisterProfileInteger("Volume.SONOS", "Intensity", "", " %", 0, 100, 1);
		
			$this->RegisterVariableInteger("Status", "Status", "Status.SONOS");
			$this->EnableAction("Status");
			$this->RegisterVariableInteger("Volume", "Volume", "Volume.SONOS");
			$this->EnableAction("Volume");
			$this->RegisterVariableInteger("Mute", "Mute", "Schalter.SONOS");
			$this->EnableAction("Mute");
			$this->RegisterVariableInteger("Station", "Station", "Station.SONOS");
			$this->EnableAction("Station");
			$this->RegisterVariableString("Radiotitel", "Radiotitel", "");
			$this->RegisterVariableString("Radiotitel_alt", "Radiotitel_alt", "");
 			$this->RegisterVariableString("Sender", "Sender", "");
// 			$this->RegisterVariableString("Logo", "Logo", "~HTMLBox");

		}

		/**
		* This function will be available automatically after the module is imported with the module control.
		* Using the custom prefix this function will be callable from PHP and JSON-RPC through:
		*
		* SNS_Play($id);
		*
		*/
		public function Play()
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/mpd.php");
			(new PHPmpd($this->ReadPropertyString("IPAddress")))->Play();
			}
		}
		
		public function Pause()
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/mpd.php");
			(new PHPmpd($this->ReadPropertyString("IPAddress")))->Pause();
      } 			
		}
		public function Stop()
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/mpd.php");
			(new PHPmpd($this->ReadPropertyString("IPAddress")))->Stop();
			}
		}
		
		public function Previous()
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {
			include(__DIR__ . "/mpd.php");
			(new PHPmpd($this->ReadPropertyString("IPAddress")))->Previous();
			}
		}
		
		public function Next()
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/mpd.php");
			(new PHPmpd($this->ReadPropertyString("IPAddress")))->Next();
			}
		}
		
		public function SetVolume($volume)
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/mpd.php");
			(new PHPmpd($this->ReadPropertyString("IPAddress")))->SetVolume($volume);
			}
		}

		public function SetMute($mute)	
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/mpd.php");
			(new PHPmpd($this->ReadPropertyString("IPAddress")))->SetMute($mute);
			}
		}

		public function SetRadio($radio)	
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/mpd.php");
			(new PHPmpd($this->ReadPropertyString("IPAddress")))->SetRadio($radio);
			}
		}

		
		
		public function RequestAction($Ident, $Value)
		{
			switch($Ident) {
				case "Station":
					switch($Value) {
						case 0: 
							$this->SetRadio($this->ReadPropertyString("Radio1"),"");
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 1: 
							$this->SetRadio($this->ReadPropertyString("Radio2"),"");
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 2: 
							$this->SetRadio($this->ReadPropertyString("Radio3"),"");
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 3: 
							$this->SetRadio($this->ReadPropertyString("Radio4"),"");
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 4: 
							$this->SetRadio($this->ReadPropertyString("Radio5"),"");
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;

					}
					break;
				case "Status":
					switch($Value) {
						case 0: //Prev
							$this->Previous();
							break;
						case 1: //Play
							$this->Play();
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 2: //Pause
							$this->Pause();
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 3: //Stop
							$this->Stop();
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 4: //Next
							$this->Next();
							break;
					}
					break;
				case "Volume":
					$this->SetVolume($Value);
					SetValue($this->GetIDForIdent($Ident), $Value);
					break;
				case "Mute":
					$this->SetMute($Value);
					SetValue($this->GetIDForIdent($Ident), $Value);
					break;

				default:
					throw new Exception("Invalid ident");
			}
		
		}
		
		//Remove on next Symcon update
		protected function RegisterProfileInteger($Name, $Icon, $Prefix, $Suffix, $MinValue, $MaxValue, $StepSize) {
		
			if(!IPS_VariableProfileExists($Name)) {
				IPS_CreateVariableProfile($Name, 1);
			} else {
				$profile = IPS_GetVariableProfile($Name);
				if($profile['ProfileType'] != 1)
					throw new Exception("Variable profile type does not match for profile ".$Name);
			}
			
			IPS_SetVariableProfileIcon($Name, $Icon);
			IPS_SetVariableProfileText($Name, $Prefix, $Suffix);
			IPS_SetVariableProfileValues($Name, $MinValue, $MaxValue, $StepSize);
			
		}
		
		protected function RegisterProfileIntegerEx($Name, $Icon, $Prefix, $Suffix, $Associations) {
		
			$this->RegisterProfileInteger($Name, $Icon, $Prefix, $Suffix, $Associations[0][0], $Associations[sizeof($Associations)-1][0], 0);
		
			foreach($Associations as $Association) {
				IPS_SetVariableProfileAssociation($Name, $Association[0], $Association[1], $Association[2], $Association[3]);
			}
			
		}
		
	
	}

?>
